; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "fe3d"
!define PRODUCT_VERSION "0.8-3"
!define PRODUCT_PUBLISHER "iCapsid.net"
!define PRODUCT_WEB_SITE "http://projects.icapsid.net/fe3d/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\fe3d.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_CHECKBOX
!insertmacro MUI_PAGE_LICENSE "..\..\..\doc\LICENSE.txt"
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "fe3d"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\fe3d.exe"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\docs\Readme.win32.txt"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${PRODUCT_NAME}-${PRODUCT_VERSION}.win32.exe"
InstallDir "$PROGRAMFILES\iCapsid.net\fe3d"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\..\..\build\release\fe3d.exe"
  SetOutPath "$INSTDIR\data\"
  SetOverwrite try
  File "..\..\..\data\arial.ttf"
  File "..\..\..\data\cisco.bmp"
  File "..\..\..\data\earth.bmp"
  File "..\..\..\data\fe_config.xml"
  File "..\..\..\data\linux.bmp"
  File "..\..\..\data\nmap-test.xml"
  File "..\..\..\data\osx.bmp"
  File "..\..\..\data\os_info-pngs.xml"
  File "..\..\..\data\os_info.xml"
  File "..\..\..\data\unknown.bmp"
  File "..\..\..\data\win_xp.bmp"
  SetOutPath "$INSTDIR\docs"
  File "..\..\..\doc\ChangeLog.txt"
  File "..\..\..\doc\LICENSE.txt"
  File "..\..\..\doc\Readme.win32.txt"
  File "..\..\..\doc\versions.txt"
  SetOutPath "$INSTDIR"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\fe3d.lnk" "$INSTDIR\fe3d.exe"
  CreateShortCut "$DESKTOP\fe3d.lnk" "$INSTDIR\fe3d.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section "Libraries" SEC02
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\..\..\..\..\..\..\..\Development\DLL\xerces-c_2_6.dll"
  File "..\..\..\..\..\..\..\..\Development\DLL\SDL_ttf.dll"
  File "..\..\..\..\..\..\..\..\Development\DLL\SDL.dll"
  File "..\..\..\..\..\..\..\..\Development\DLL\libpng13.dll"
  File "..\..\..\..\..\..\..\..\Development\DLL\zlib1.dll"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\fe3d.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\fe3d.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\zlib1.dll"
  Delete "$INSTDIR\libpng13.dll"
  Delete "$INSTDIR\SDL.dll"
  Delete "$INSTDIR\SDL_ttf.dll"
  Delete "$INSTDIR\xerces-c_2_6.dll"
  Delete "$INSTDIR\docs\versions.txt"
  Delete "$INSTDIR\docs\Readme.win32.txt"
  Delete "$INSTDIR\docs\LICENSE.txt"
  Delete "$INSTDIR\docs\ChangeLog.txt"
  Delete "$INSTDIR\data\win_xp.bmp"
  Delete "$INSTDIR\data\unknown.bmp"
  Delete "$INSTDIR\data\os_info.xml"
  Delete "$INSTDIR\data\os_info-pngs.xml"
  Delete "$INSTDIR\data\osx.bmp"
  Delete "$INSTDIR\data\nmap-test.xml"
  Delete "$INSTDIR\data\linux.bmp"
  Delete "$INSTDIR\data\fe_config.xml"
  Delete "$INSTDIR\data\earth.bmp"
  Delete "$INSTDIR\data\cisco.bmp"
  Delete "$INSTDIR\data\arial.ttf"
  Delete "$INSTDIR\stdout.txt"
  Delete "$INSTDIR\stderr.txt"
  Delete "$INSTDIR\fe3d.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$DESKTOP\fe3d.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\fe3d.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\docs"
  RMDir "$INSTDIR\data\"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
