/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_PNG_SCREEN
#define _H_F3_PNG_SCREEN

#include "fe_util.hpp"
#include "gl_util.hpp"
#include "png.h"
#include "version.h"

#ifndef GL_BGR
#define GL_BGR GL_BGR_EXT
#endif // GL_BGR


class PNGScreen
{

public:
	PNGScreen();

	bool init();
	bool kill();
	void doStuff();

	void initText();

	static void writeRowCallback(png_structp png_ptr, png_uint_32 row, int pass);
	static void pngError(png_structp, png_const_charp);
	static void pngWarning(png_structp, png_const_charp);

public:
	unsigned int ss_id;


	// Text66
	string m_Title;			// Set to ?
    string m_Author;		// Name of user
	string m_Copyright;		// Copyright by user.
	string m_Source;		// Set to video card, glGetString stuff.
	string m_Software;		// Set to fe3d version
	string m_Comment;		// Possibly extensions used?
	string m_Time;			// Time
	string m_Description;	// fps, scan file, etc.

private: // PNG Stuff
	png_structp		m_png_ptr;
	png_infop		m_info_ptr;
	FILE*			m_fp;
	GLint			viewPort[4];
	GLubyte			*pixels;



};

/*
 Title            Short (one line) title or
                     caption for image
    Description      Description of image (possibly long)
    Creation Time    Time of original image creation
                     (usually RFC 1123 format, see below)
    Disclaimer       Legal disclaimer
    Warning          Warning of nature of content
    Comment          Miscellaneous comment; conversion
                     from other image format


*/
#endif // _H_F3_PNG_SCREEN

