/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_TEX_CACHE
#define _H_F3_TEX_CACHE

#include "gl_util.hpp"
#include "fe_util.hpp"

/**
 * \ingroup Miscellaneous Files
 *
 * \version 0.0.6
 * first version
 *
 * \date 01-27-2004
 *
 * \author Stou
 *
 * \par license GPL
 * 
 * This class is the texture loader/unloader and store for textures.
 * it can be used in 'load on demand' or 'load all at once' modes.
 *
 */
class TextureStore
{

public:
	TextureStore();
	~TextureStore();

public: // Store Management functions;

	void addOSTexture(OS_FAMILY::OS osid, GLuint texId);
	GLuint getOSTexture(OS_FAMILY::OS osid);

	// Adds a port # or Service name textures
	void addServiceTexture(const char* ps);
	GLuint getServiceTexture(const char* ps);

	// Loads a texture
	void loadOSTexture(OS_FAMILY::OS osid, const char* name);

	GLUtil*	m_glUtil;

private:
	map<OS_FAMILY::OS,GLuint> m_texOSFam;
	map<string,GLuint> m_texPorts;


};

class OSTexture
{
public:
	GLuint			m_TexId;
	char*			fileName;
	char*			famName;
	OS_FAMILY::OS	famId;
	bool			loaded;
};

#endif // _H_F3_TEX_CACHE
